#include "IterativeDeepeningDepthFirstSearcher.h"

/**
 * IterativeDeepeningDepthFirstSearcher.cc - a simple implementation
 * of iterative-deepening depth-first search.
 *
 * @author Todd Neller
 * @version 1.0
 *

Copyright (C) 2003 Todd Neller

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

Information about the GNU General Public License is available online at:
  http://www.gnu.org/licenses/
To receive a copy of the GNU General Public License, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.

 */


/**
 * Constructor - initialize searcher
 */
IterativeDeepeningDepthFirstSearcher::IterativeDeepeningDepthFirstSearcher() {
  searcher = 0;
}


/**
 * Destructor - free up depth-limited searcher if applicable
 */
IterativeDeepeningDepthFirstSearcher::~IterativeDeepeningDepthFirstSearcher() {
  if (searcher != 0) {
    delete searcher;
    searcher = 0;
    goalNode = 0;
  }
}



/**
 * <code>search</code> - perform iterative-deepening depth-first
 * search by performing successive depth-limited searches with
 * increasing depth-limits.  This particular implementation of
 * ID-DFS is recursive.
 *
 * @param rootNode a <code>SearchNode *</code> value - the initial node
 * @return a <code>bool</code> value - whether or not goal node was
 * found */
bool IterativeDeepeningDepthFirstSearcher::search(SearchNode *rootNode) {
  
  // implement
  
  // Perform successive depth-limited searches with depth limit
  // 0, 1, ... until a goal node is found.  Accumulate node
  // counts of successive searches and update goalNode
  // accordingly.

  return true;
}
